"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

var _parse_url = _interopRequireDefault(require("./parse_url"));

var _git_clone = _interopRequireDefault(require("./git_clone"));

var _git_update = _interopRequireDefault(require("./git_update"));

var _install = _interopRequireDefault(require("./install"));

var _run_generator = _interopRequireDefault(require("./run_generator"));

var _write_routes = _interopRequireDefault(require("./write_routes"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * git 类型的流程是：
 * 1、解析 url => git 地址
 * 2、如果不存在，则 git clone 到本地临时目录
 * 3、git pull 更新到最新分支
 * 4、依赖处理，处理依赖冲突、依赖安装、依赖写入
 * 5、写区块到项目目录中
 * 6、写路由
 */
var _default = [{
  name: 'parseUrl',
  task: _parse_url.default
}, {
  name: 'gitClone',
  task: _git_clone.default
}, {
  name: 'gitUpdate',
  task: _git_update.default
}, {
  name: 'install',
  task: _install.default
}, {
  name: 'runGenerator',
  task: _run_generator.default
}, {
  name: 'writeRoutes',
  task: _write_routes.default
}];
exports.default = _default;